/*
	Twilight Prophecy SDK
	A multi-platform development system for virtual reality and multimedia.

	Copyright (C) 1997-2002 Twilight 3D Finland Oy Ltd.


    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.


	source:
		PixelFormat example

	revision history:
		Jun/30/1999 - Jukka Liimatta - initial revision
		Aug/24/2001 - Jukka Liimatta - cleanup reporting
*/
#include <prcore/prcore.hpp>
#include <iostream>

using namespace prcore;
using namespace std;


int main()
{
	// palette
	Color32 palette[256];

	// PA88
	PixelFormat format0(16,palette,0xff00,0x00ff);

	// IA88
	PixelFormat format1(16,0xff00,0x00ff);

	// AI44
	PixelFormat format2(8,0x0f,0xf0);

	// BGR888
	PixelFormat format3(24,0x0000ff,0x00ff00,0xff0000,0x0);

	// stock formats
	PixelFormat format4( INTENSITY8 );
	PixelFormat format5( PALETTE8(palette) );
	PixelFormat format6( RGB565 );
	PixelFormat format7( RGB888 );
	PixelFormat format8( ARGB1555 );
	PixelFormat format9( ARGB4444 );
	PixelFormat formata( ARGB8888 );

	// compile report
	char* report1 = format4.IsIntensity() ? "I8 is intensity format." : "error";
	char* report2 = format0.IsIndexed() ? "PA88 is indexed format." : "error";
	
	// cout report
	cout << report1 << endl;
	cout << report2 << endl;

	return 0;
}
