/*
	Twilight Prophecy SDK
	A multi-platform development system for virtual reality and multimedia.

	Copyright (C) 1997-2002 Twilight 3D Finland Oy Ltd.


    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.


	source: 
		Timer example

	revision history:
		Jan/01/1999 - Jukka Liimatta - initial revision
*/
#include <prcore/prcore.hpp>
#include <iostream>

using namespace prcore;
using namespace std;


namespace
{
	float delay()
	{
		float j = 0;
		int count = 210000;

		do
		{
			j += 0.12f;
			j *= j;
		} while ( --count );

		// return j to defeat optimizer
		return j;
	}
	
} // namespace


int main()
{
	Timer timer;
	float time0 = timer.GetTime();

	delay();
	
	float time1 = timer.GetTime();
	cout << "delta: " << (time1-time0)*1000 << " ms" << endl;

	return 0;
}
