/*
	Twilight Prophecy SDK
	A multi-platform development system for virtual reality and multimedia.

	Copyright (C) 1997-2002 Twilight 3D Finland Oy Ltd.
*/
#ifndef PRCORE_FILENAME_HPP
#define PRCORE_FILENAME_HPP


namespace prcore
{

	// filename manipulation functions
	
	const char*		GetFilenameEXT(const char* filename);		// get extension of given filename
	const char*		GetFilenameNoEXT(const char* filename);		// get filename without extension
	const char*		GetFilenamePath(const char* filename);		// get path of given filename
	const char*		GetFilenameNoPath(const char* filename);	// get filename without path

	
	// ANSI is designed to make case of character quick to change,
	// certain characters are illegal in a filename because of this.
	
	inline char tolower(char c)
	{
		return c | 0x20;
	}

	inline char toupper(char c)
	{
		return c & 0xdf;
	}

} // namespace prcore


#endif
