/*
	Twilight Prophecy SDK
	A multi-platform development system for virtual reality and multimedia.

	Copyright (C) 1997-2002 Twilight 3D Finland Oy Ltd.
*/
/*
  NEVER include this header manually, included by system when needed
*/

#ifndef PRCORE_CONFIGURED
#if defined( __linux__ )
#define PRCORE_CONFIGURED

// user entry point
extern int prmain(int argc, char** argv);


// =======================================
// generic settings
// =======================================

// 
// all this must be eventually depreciated
#include <iostream.h>

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h> 
#include <ctype.h>
#include <string.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/keysym.h>

#include <GL/glx.h>

// platform
#define __LINUX__
#define PRCORE_PLATFORM_LINUX

// interface
#define PRCORE_EXPORT
#define PRCORE_IMPORT
#define PRAPI

#define __cdecl // not a part of ANSI C++

// header mode
#ifdef PRCORE_COMPILE_RUNTIME
#define PRCORE_API PRCORE_EXPORT
#else
#define PRCORE_API PRCORE_IMPORT
#endif

// flags
#define PR_LITTLE_ENDIAN
#define PR_X86_SIMD

// types
typedef	signed char   int8;
typedef	signed short  int16;
typedef signed int    int32;
typedef signed long long	int64;
typedef	unsigned char		uint8;
typedef	unsigned short		uint16;
typedef unsigned int		uint32;
typedef unsigned long long	uint64;

// additional defines

#define min(X,Y) (X <? Y)
#define max(X,Y) (X >? Y)

#ifndef NULL
#define NULL 0
#endif

// string compare
inline int stricmp(const char* a, const char* b) {
  return strcasecmp(a,b);
}

inline int _stricmp(const char* a, const char* b) {
  return strcasecmp(a,b);
}


// window handle
struct WinHandle
{
  Display *dpy;
  Window win;
  Atom delete_atom;
  XVisualInfo *VisualInfo;
  
  Pixmap EmptyPixmap;
  Cursor EmptyCursor;
};


#ifdef PRCORE_IMPLEMENT_MAIN

#include <prcore/exception.hpp>

extern int prmain(int argc, char** argv);

// system entry point
int main(int argc, char** argv)
{
  int result;

  try
    {
      result = prmain(argc, argv);
    }
  catch (prcore::Exception& e)
    {
      e.DrawDialog();
    }

  return result;
}

#endif // PRCORE_IMPLEMENT_MAIN

#endif
#endif //  PRCORE_CONFIGURED
