/*
	Twilight Prophecy SDK
	A multi-platform development system for virtual reality and multimedia.

	Copyright (C) 1997-2002 Twilight 3D Finland Oy Ltd.
*/
#ifndef PRCORE_REFCOUNT_HPP
#define PRCORE_REFCOUNT_HPP


#include <prcore/string.hpp>


namespace prcore
{

	class RefCount
	{
		public:
		
		void			SetName(const char* name) { mName = name; }
		const char*		GetName() const { return mName; }
		void			AddRef() { ++mRefCount; }
		int				GetRefCount() const { return mRefCount; }
		void			Release() { if ( !--mRefCount ) delete this; }

		protected:

		RefCount() : mRefCount(1) {}
		RefCount(const RefCount& other) { *this = other; }
virtual	~RefCount() {}

		void			operator = (const RefCount& other) { mRefCount = other.mRefCount; mName = other.mName; }

		int				mRefCount;
		String			mName;
	};

} // namespace prcore


#endif
