/*
	Twilight Prophecy SDK
	A multi-platform development system for virtual reality and multimedia.

	Copyright (C) 1997-2002 Twilight 3D Finland Oy Ltd.
*/
#ifndef PRIMPORT_Q2MDL_HPP
#define PRIMPORT_Q2MDL_HPP


namespace primport
{

	// ====================================
	// structs
	// ====================================

	typedef point2f	TexCoordsQ2MDL;

	enum TypeQ2MDL
	{
		NONE,
		TRIANGLE_STRIP,
		TRIANGLE_FAN
	};

	struct VertexQ2MDL
	{
		point3f	point;
		vec3f	normal;
	};

	struct TriangleQ2MDL
	{
		int	vertindex[3];
		int	texindex[3];
	};

	struct FrameQ2MDL
	{
		prcore::String				name;
		prcore::Array<VertexQ2MDL>	vertexarray;
	};

	struct VertexInfoQ2MDL
	{
		TexCoordsQ2MDL	texcoords;
		int				index;
	};

	struct CommandsQ2MDL
	{
		TypeQ2MDL						type;
		prcore::Array<VertexInfoQ2MDL>	vertinfo;
	};

	// ====================================
	// importer
	// ====================================

	class ImportQ2MDL : public prcore::RefCount
	{
		public:

		prcore::Array<prcore::String>	skins;
		prcore::Array<TriangleQ2MDL>	triangles;
		prcore::Array<TexCoordsQ2MDL>	texcoords;
		prcore::Array<FrameQ2MDL>		frames;
		prcore::Array<CommandsQ2MDL>	commands;

		ImportQ2MDL();
		ImportQ2MDL(prcore::Stream& stream);
		ImportQ2MDL(const char* filename);
		~ImportQ2MDL();
	};

} // namespace primport


#endif
