/*
	Twilight Prophecy SDK
	A multi-platform development system for virtual reality and multimedia.

	Copyright (C) 1997-2002 Twilight 3D Finland Oy Ltd.
*/
#ifndef PRMATH_EULER_HPP
#define PRMATH_EULER_HPP


namespace prmath
{

	enum EulerOrder
	{
		EULER_XYZ,
		EULER_XZY,
		EULER_YXZ,
		EULER_YZX,
		EULER_ZXY,
		EULER_ZYX
	};

	const float pi = 3.14159265358979323846264338327950288419716939937510f;

	inline float DegToRad(float angle)
	{
		return angle * (pi/180);
	}

	inline float RadToDeg(float angle)
	{
		return angle * (180/pi);
	}
	
} // namespace prmath


#endif
