/*
	Twilight Prophecy SDK
	A multi-platform development system for virtual reality and multimedia.

	Copyright (C) 1997-2002 Twilight 3D Finland Oy Ltd.
*/
#ifndef PRMATH_TYPENAME_HPP
#define PRMATH_TYPENAME_HPP


namespace prmath
{

	struct Vector2;
	struct Vector3;
	struct Vector4;
	struct Plane;
	struct Matrix4x4;
	struct Quaternion;
	struct Box;
	struct Line;
	struct Cone;
	struct Sphere;

} // namespace prmath


#ifdef PRMATH_TYPENAME

typedef prmath::Vector2		vec2f;
typedef prmath::Vector3		vec3f;
typedef prmath::Vector4		vec4f;
typedef prmath::Vector2		point2f;
typedef prmath::Vector3		point3f;
typedef prmath::Vector4		point4f;
typedef prmath::Vector3		color3f;
typedef prmath::Vector4		color4f;
typedef prmath::Plane		plane3f;
typedef prmath::Matrix4x4	matrix4x4f;
typedef prmath::Quaternion	quat4f;
typedef prmath::Box			box3f;
typedef prmath::Line		line3f;
typedef prmath::Cone		cone3f;
typedef prmath::Sphere		sphere3f;

#endif // PRMATH_TYPENAME


#endif
