/** newline (a tool for the linux build of Prophecy3d)
    (C) 2001 - Edmond Cote (edmond.cote@twilight3d.com)

    see README file for more information.

    Little program to add newlines at the end of each file, since gcc 2.96 and
    above will give out warnings when a newline is not found at the end of a
    file. Occassionally, gcc will also crash when too many of those errors
    are found.

    On a final note, there is no doubt in my find that it would of been more
    efficient to use 'x' scripting language. As it stood, I did try to do 
    something in Perl, but it didn't work out. So if evreyone as a nicer way
    to do this, please let me know

*/
    
#include <stdio.h>
#include <stdlib.h>

int exists(char *file)
{
  FILE *f;
  f=fopen((char *)file,"ro");
  if(f != NULL) {
    return 1; // true
    fclose(f);
  }
  else   
    return 0; // false
}

int main(int argc, char **argv)
{
  int i;
  FILE *f;

  if(strcmp(argv[1],"--help")==0) {
      fprintf(stderr,"newline - a tool for the linux build of prophecy3d\nsee \
README file for more information\n");
      exit(1);
    }
  
  for(i=1;i<argc;i++)
    {
      fprintf(stdout,"%s\n",(char *)argv[i]);
      
      if(exists(argv[i])==1) {
	  /* "a" is for 'append'*/
	  f=fopen((char *)argv[i],"a");
	  if(f!=NULL) {
	      fprintf(f,"\n");
	      fclose(f);
	    }
	}
      else {
	  fprintf(stderr,"file: %s, does not exist!\n",argv[i]);
	  exit(1); 
	}
    } 
  exit(0);
}
