/*
	Twilight Prophecy SDK
	A multi-platform development system for virtual reality and multimedia.

	Copyright (C) 1997-2002 Twilight 3D Finland Oy Ltd.


    This software is provided 'as-is', without any express or implied
    warranty.  In no event will the authors be held liable for any damages
    arising from the use of this software.

    Permission is granted to anyone to use this software for any purpose,
    including commercial applications, and to alter it and redistribute it
    freely, subject to the following restrictions:

    1. The origin of this software must not be misrepresented; you must not
       claim that you wrote the original software. If you use this software
       in a product, an acknowledgment in the product documentation would be
       appreciated but is not required.
    2. Altered source versions must be plainly marked as such, and must not be
       misrepresented as being the original software.
    3. This notice may not be removed or altered from any source distribution.


	source:
		filename implementation

	revision history:
		Jan/24/2001 - Jukka Liimatta - initial revision/renaissance build
*/
#include <string.h>
#include <prcore/filename.hpp>

using namespace prcore;


const char* prcore::GetFilenameEXT(const char* filename)
{
	int len = (int)strlen(filename);
	while ( len-- )
	{
		if ( *(filename+len) == '.' )
		{
			return filename + len + 1;
		}
	}
	return "";
}


const char* prcore::GetFilenameNoEXT(const char* filename)
{
	static char file[256];

	strcpy(file,filename);
	char* ptr = file + strlen(file) - 1;

	while ( ptr-- >= file )
	{
		if ( *ptr=='.' )
		{
			*ptr = '\0';
			return file;
		}
	}
	return "";
}


const char* prcore::GetFilenamePath(const char* filename)
{
	static char path[256];

	strcpy(path,filename);
	char* ptr = path + strlen(path) - 1;

	while ( ptr-- >= path )
	{
		if ( *ptr=='\\' || *ptr=='/' || *ptr==':' )
		{
			ptr[1] = 0;
			return path;
		}
	}
	return "";
}


const char* prcore::GetFilenameNoPath(const char* filename)
{
	int len = (int)strlen(filename);
	while ( len-- )
	{
		const char* ptr = filename + len;
		char c = *ptr;
		if ( c=='\\' || c=='/' || c==':' )
		{
			return ptr + 1;
		}
	}
	return filename;
}

