; ============================================================
; x86 cpu capabilities
;
; Copyright (C) 1999-2002 Twilight 3D Finland Oy Ltd.
; http://www.twilight3d.com
; ============================================================
	
	segment .text
	
	; export
	global _x86_cpu_caps
	global  x86_cpu_caps_
	global  x86_cpu_caps


	; in: none
	; out: eax - processor caps bitmask
_x86_cpu_caps:
x86_cpu_caps_:
x86_cpu_caps:

	; satisfy Linux requirements
	push    ebx
	push    edx
	
	; test if cpu can do CPUID
	pushfd
	pop     eax
	mov     ebx,eax
	xor     eax,0x200000
	push    eax
	popfd
	pushfd
	pop     eax
	cmp     eax,ebx
	jnz     .cpuid_found
	xor     eax,eax
	jmp     .cpu_caps_exit
.cpuid_found:

	; default: no caps
	xor     eax,eax

	; detect MMX
	push    eax
	mov     eax,1
	cpuid
	pop     eax
	test    edx,0x800000
	jz      .no_mmx
	or      eax,1  ; MMX detected.
.no_mmx:

	; detect Streaming Simd Extensions ( SSE )
	test    edx,0x2000000
	jz      .no_sse
	or      eax,4  ; SSE detected.
.no_sse:

	; detect Streaming Simd Extensions 2 ( SSE2 )
	test    edx,0x4000000
	jz      .no_sse2
	or      eax,8  ; SSE2 detected.
.no_sse2:

	; detect AMD 3DNow!
	push    eax
	mov     eax,0x80000001
	cpuid
	pop     eax
	test    edx,0x80000000
	jz      .no_3dnow
	or      eax,2
.no_3dnow:
.cpu_caps_exit:
	pop     edx
	pop     ebx
	ret
